/*
	$Id: order.c,v 1.11 2008/08/09 09:21:37 alex Exp $
	order.c--- order
*/

#ifndef	lint
static char *rcsid __attribute__((unused)) = "$Id: order.c,v 1.11 2008/08/09 09:21:37 alex Exp $";
#endif

#include	<stdio.h>
#include	<stdarg.h>
#include	<string.h>
#include	"edb/edb.h"

EdbColumnOrder
edb_column_order_new(utf8_t *sqlname)
{
	EdbColumnOrder	co;

	co = (EdbColumnOrder)malloc(sizeof(struct EDB_COLUMN_ORDER));
	if(co==NULL) return NULL;
	bzero(co, sizeof(struct EDB_COLUMN_ORDER));
	co->sqlname = (utf8_t *)strdup((char *)sqlname);
	return co;
}

void
edb_column_order_free(EdbColumnOrder co)
{

	FREE(co->sqlname);
	free(co);
}

static
utf8_t *
edb_order_make_column(EdbContext ec, utf8_t *as, EdbTableInfo ti, EdbColumnOrder co)
{
	EdbColumnInfo	ci;
	utf8_t	*order = NULL;

	if(co==NULL) return NULL;
	if(!strcmp((char *)co->sqlname, EDB_BASE_EID)
		|| !strcmp((char *)co->sqlname, EDB_BASE_EOID)
		|| !strcmp((char *)co->sqlname, EDB_BASE_MTIME)) {
		asprintf((char **)&order, "%s.%s%s", as ? as : TABLE_SN(ti), co->sqlname, co->desc ? " DESC" : "");
		return order;
	}
	ci = edb_table_seek_column_by_sqlname(ec, ti, co->sqlname);
	if(ci==NULL) {
		edb_trace(ec, "edb_order_make_column: can't make order (%s)\n", co->sqlname);
		return NULL;
	}
	if(edb_table_column_reldb_elements(ec, ti, NULL, ci)==1) {
		if(ci->typeInfo->typeID==EDB_TYPE_IPv4CIDR || ci->typeInfo->typeID==EDB_TYPE_IPv4ADDR) {
			asprintf((char **)&order, "%s.%s::inet%s", as ? as : TABLE_SN(ti), ColumnSN(ci), co->desc ? " DESC" : "");
		} else {
			asprintf((char **)&order, "%s.%s%s", as ? as : TABLE_SN(ti), ColumnSN(ci), co->desc ? " DESC" : "");
		}
	} else {
		if(!strcmp(ci->typeInfo->SQL_type, "date")) {
			asprintf((char **)&order, "timestamp(%s.%s[1])%s", as ? as : TABLE_SN(ti), ColumnSN(ci), co->desc ? " DESC" : "");
		} else if(ci->typeInfo->typeID==EDB_TYPE_IPv4CIDR || ci->typeInfo->typeID==EDB_TYPE_IPv4ADDR) {
			asprintf((char **)&order, "(%s.%s[1])::inet%s", as ? as : TABLE_SN(ti), ColumnSN(ci), co->desc ? " DESC" : "");
		} else {
			asprintf((char **)&order, "%s.%s[1]%s", as ? as : TABLE_SN(ti), ColumnSN(ci), co->desc ? " DESC" : "");
		}
	}
	return order;
}

utf8_t *
edb_order_make(EdbContext ec, EdbTableInfo ti, utf8_t *as, Link l_order)
{
	Link	l, lstr;
	utf8_t	*order, *str;

	if(l_order==NULL) return edb_table_make_order(ec, ti, as);

	lstr = NULL;
	ForLink(l, l_order) {
		if((order = edb_order_make_column(ec, as, ti, (EdbColumnOrder)l->d))) {
			LinkAppend(lstr, link_atom_new(order, free));
		}
	}
	asprintf((char **)&order, "%s.%s", as ? as : TABLE_SN(ti), EDB_BASE_EID);
	LinkAppend(lstr, link_atom_new(order, free));
	str = (utf8_t *)str_concatenate(lstr, ',');
	link_free(lstr);
	return str;
}


