/*
$Id: person.c,v 1.25 2012/04/03 03:51:13 alex Exp alex $
	person.c--- person
	(C) Copyright 2002 by Alex
*/

#ifndef lint
static char * rcsid __attribute__((unused)) = "$Id: person.c,v 1.25 2012/04/03 03:51:13 alex Exp alex $";
#endif

#include	<stdio.h>
#include	<stdlib.h>
#include	<strings.h>
#include	"edb/edb.h"
#include	"edb/person.h"

#if 0
static eid_t	title_teacher_list[] = TITLE_TEACHER_LIST;
static eid_t	title_personnel_list[] = TITLE_PERSONNEL_LIST;
#else

static eid_t	dummy_title_list[] = {0};

eid_t	*edb_title_teacher_list = dummy_title_list;
eid_t	*edb_title_personnel_list = dummy_title_list;

void
edb_title_initialize(EdbContext ec)
{
	EdbTableInfo	ti;
	EdbColumnInfo	ci;
	utf8_t	*query;
	int		*eids;
	int		i, n;

	ti = edb_table_get_by_name(ec, (utf8_t *)EDB_TABLE_Title_XN);
	if(ti==NULL) return;
	ci = edb_table_seek_column_by_xmlname(ec, ti, (utf8_t *)TITLE_COLUMN_ATTRIBUTE_XN);
	if(ci==NULL) return;

	asprintf((char **)&query,
		"SELECT " EDB_BASE_EID " FROM %s WHERE %s*=%d", TABLE_SN(ti), ColumnSN(ci), TITLE_ATTRIBUTE_Teacher);
	edb_pgsql_query_integers(ec, &eids, &n, query);
	FREE(query);
	if(n>0) {
		edb_title_teacher_list = (eid_t *)malloc(sizeof(eid_t)*(n+1));
		for(i=0; i<n; ++i) edb_title_teacher_list[i] = eids[i];
		edb_title_teacher_list[i] = 0;
		FREE(eids);
//		for(i=0; i<n; ++i) edb_trace(ec, "teacher = %d\n", edb_title_teacher_list[i]);
	}

	asprintf((char **)&query,
		"SELECT " EDB_BASE_EID " FROM %s WHERE %s*=%d", TABLE_SN(ti), ColumnSN(ci), TITLE_ATTRIBUTE_Personnel);
	edb_pgsql_query_integers(ec, &eids, &n, query);
	FREE(query);
	if(n>0) {
		edb_title_personnel_list = (eid_t *)malloc(sizeof(eid_t)*(n+1));
		for(i=0; i<n; ++i) edb_title_personnel_list[i] = eids[i];
		edb_title_personnel_list[i] = 0;
		FREE(eids);
//		for(i=0; i<n; ++i) edb_trace(ec, "personnel = %d\n", edb_title_personnel_list[i]);
	}
}
#endif

utf8_t *
edb_person_email(EdbContext ec, EdbTupleInfo tuple)
{
	Link	lc;

	if(tuple==NULL) return NULL;
	if(!TupleIsPerson(tuple) && !TupleIsPersonification(tuple)) return NULL;
	ForTupleColumn(lc, tuple) {
		EdbTupleColumn	tc = (EdbTupleColumn)lc->d;

		if(tc->ci->typeInfo->basicTypeID == EDB_TYPE_EMAIL && tc->datum) {
			EdbDatum	datum = (EdbDatum) tc->datum;

			if(DatumEnglishIsValid(datum)) return (utf8_t *)strdup((char *)DatumEnglish(datum));
		}
	}
	return NULL;
}

utf8_t *
edb_person_certificate(EdbContext ec, EdbTupleInfo tuple)
{
	Link	lc;

	if(tuple==NULL) return NULL;
	if(!TupleIsPerson(tuple)) return NULL;
	ForTupleColumn(lc, tuple) {
		EdbTupleColumn	tc = (EdbTupleColumn)lc->d;

		if(tc->ci->typeInfo->basicTypeID == EDB_TYPE_CERTIFICATE && tc->datum) {
			EdbDatum	datum = (EdbDatum) tc->datum;

			if(DatumEnglishIsValid(datum)) return (utf8_t *)strdup((char *)DatumEnglish(datum));
		}
	}
	return NULL;
}

#define	ORGAN_COLUMN_MEMEBER_XML	"organization.member"
#define	ORGAN_COLUMN_MEMEBER_TITLE_XML	"organization.member.title"

#if 1
static
int
check_position(eid_t eid, int teacher)
{
	eid_t	*e;

	if(!EIDisVALID(eid)) return FALSE;
	if(teacher) {
		for(e=edb_title_teacher_list; *e; ++e) {
			if(EIDisVALID(*e) && *e==eid) return TRUE;
		}
	} else {
		eid_t	*e;
		for(e=edb_title_personnel_list; *e; ++e) {
			if(EIDisVALID(*e) && *e==eid) return TRUE;
		}
	}
	return FALSE;
}
#else
static
int
check_position(eid_t eid, int teacher)
{
	int	i;

	if(!EIDisVALID(eid)) return FALSE;
	if(teacher) {
		for(i=0; i<Ns(title_teacher_list); ++i) {
			if(EIDisVALID(title_teacher_list[i]) && title_teacher_list[i]==eid) return TRUE;
		}
	} else {
		for(i=0; i<Ns(title_personnel_list); ++i) {
			if(EIDisVALID(title_personnel_list[i]) && title_personnel_list[i]==eid) return TRUE;
		}
	}
	return FALSE;
}
#endif


static
void
edb_person_check_position(EdbContext ec, EdbTupleInfo tuple)
{
	EdbTableInfo	organ_ti;
	utf8_t	*query, *condition;
	Link	l, l_eid;
	int	n;

	if(tuple==NULL) return;
	if(!TupleIsPerson(tuple)) return;

#ifdef EDB_READER
#else /* !EDB_READER */
	tuple->tuple_auth_user = edb_auth_registered(ec, TupleEID(tuple));
	if(!tuple->tuple_auth_user) return;
#endif /* EDB_READER */

	organ_ti = edb_table_get_by_name(ec, (utf8_t *)EDB_TABLE_ORGANIZATION_XN);
	if(organ_ti==NULL) return;

#if 0
#if 0
	asprintf((char **)&query, "SELECT %s FROM %s WHERE %s*=%d AND %s*=%d",
		EDB_BASE_EID,
		TABLE_SN(organ_ti),
		ORGAN_COLUMN_UPPER_SQL, ORGAN_UNIV_EID,
		ORGAN_COLUMN_MEMEBER_SQL,
		TupleEID(tuple));
#else
	asprintf((char **)&query, "SELECT %s FROM %s WHERE %s",
		EDB_BASE_EID,
		TABLE_SN(organ_ti),
		condition = edb_condition_make(ec, organ_ti, CONDITION_LOGIC_AND,
			ConditionEIDMatchNoExpand("@.upper", ORGAN_UNIV_EID),
			ConditionEIDMatchNoExpand("@.member", TupleEID(tuple)),
			ConditionTerminate)
		);
	FREE(condition);
#endif
#else
	asprintf((char **)&query, "SELECT %s FROM %s WHERE %s",
		EDB_BASE_EID,
		TABLE_SN(organ_ti),
		condition = edb_condition_make(ec, organ_ti, CONDITION_LOGIC_AND,
			ConditionEIDMatchNoExpand("@.upper", ORGAN_UNIV_EID),
			ConditionEIDMatchNoExpand("@.member", TupleEID(tuple)),
			ConditionTerminate)
		);
	FREE(condition);
	l_eid = edb_pgsql_query_one_field(ec, query, &n);
	FREE(query);
	LinkAppend(l_eid, link_atom_new_spf("%d", ORGAN_UNIV_EID));
#endif
	ForLink(l, l_eid) {
		eid_t	organ_eid = ATOI(l->d);
		EdbTupleInfo	organ_tuple;
		EdbTupleColumn	tc;
		EdbDatum	d;

		if(!EIDisVALID(organ_eid)) continue;
		organ_tuple = edb_tuple_get(ec, organ_eid, EDB_TUPLE_GET_template_table, organ_ti, 0);
		if(organ_tuple==NULL) continue;
		if(!TupleAvail(organ_tuple)) continue;
		tc = edb_tuple_seek_column_by_xmlname(ec, organ_tuple, (utf8_t *)ORGAN_COLUMN_MEMEBER_XML);
		if(tc==NULL) continue;
		if(!edb_organization_is_inside(ec, organ_tuple, ORGAN_UNIV_EID)) continue;
		ForTCDatum(d, tc) {
			if(!edb_datum_at_present(ec, d)) continue;
			if(DatumEID(d) == TupleEID(tuple)) {
				Link	lcc;

				ForLink(lcc, d->l_child) {
					EdbTupleColumn	ttc = lcc->d;

					if(!strcmp((char *)ttc->ci->xmlname, ORGAN_COLUMN_MEMEBER_TITLE_XML)) {
						EdbDatum	td;

						ForTCDatum(td, ttc) {
							if(!edb_datum_at_present(ec, td)) continue;
							if(check_position(DatumEID(td), FALSE)) tuple->tuple_auth_personnel = TRUE;
							if(check_position(DatumEID(td), TRUE)) tuple->tuple_auth_teacher = TRUE;
						}
					}
				}
			}
			if(tuple->tuple_auth_personnel && tuple->tuple_auth_teacher) break;
		}
		if(tuple->tuple_auth_personnel && tuple->tuple_auth_teacher) break;
	}
	EdbLinkFree(l_eid);
}

int
edb_person_is_user(EdbContext ec, EdbTupleInfo tuple)
{

	if(tuple==NULL || !TupleAvail(tuple)) return FALSE;
	if(!tuple->tuple_auth_level_checked) {
		edb_person_check_position(ec, tuple);
		tuple->tuple_auth_level_checked = TRUE;
	}
	return tuple->tuple_auth_user;
}

int
edb_person_is_personnel(EdbContext ec, EdbTupleInfo tuple)
{

	if(tuple==NULL || !TupleAvail(tuple)) return FALSE;
	if(!tuple->tuple_auth_level_checked) {
		edb_person_check_position(ec, tuple);
		tuple->tuple_auth_level_checked = TRUE;
	}
	return tuple->tuple_auth_personnel;
}

int
edb_person_is_teacher(EdbContext ec, EdbTupleInfo tuple)
{

	if(tuple==NULL || !TupleAvail(tuple)) return FALSE;
	if(!tuple->tuple_auth_level_checked) {
		edb_person_check_position(ec, tuple);
		tuple->tuple_auth_level_checked = TRUE;
	}
	return tuple->tuple_auth_teacher;
}


