/*
	$Id: tex.c,v 1.11 2012/04/03 03:51:13 alex Exp alex $
	html.c--- HTML misc command
*/

#ifndef	lint
static char *rcsid __attribute__((unused)) = "$Id: tex.c,v 1.11 2012/04/03 03:51:13 alex Exp alex $";
#endif

#include	<stdio.h>
#include	<stdlib.h>
#include	<stdarg.h>
#include	<unistd.h>
#include	<sys/types.h>
#include	<ctype.h>
#include	<string.h>
#include	<signal.h>
#include	"edb/edb.h"
#include	"edb/tex.h"

int
tex_text_puts(EdbContext ec, utf8_t *s, FILE *fp)
{
	register utf8_t	c;

	while((c=*s++)!='\0') {
		switch(c) {
		case '%':	fputs("\\%", fp);	break;
		case '{':	fputs("\\{", fp);	break;
		case '}':	fputs("\\}", fp);	break;
		case '&':	fputs("\\&", fp);	break;
		case '_':	fputs("\\_", fp);	break;
		case '<':	fputs("{$<$}", fp);	break;
		case '>':	fputs("{$>$}", fp);	break;
		case '~':	fputs("\\~{}", fp);	break;
		default:	fputc(c, fp);		break;
		}
	}
	return 0;
}

utf8_t *
tex_make_sqlname(EdbContext ec, utf8_t *d, utf8_t *s)
{
	register ucs4_t	*ustr, *c;

	ustr = UTF8toUCS4((utf8_t *)s);
	for(c=ustr; (*c)!=UCS4_NULL; ++c) {
		if(ucs4_isdigit(*c)) {
			*c = *c-'0' + UCS4_W0;
		} else if(ucs4_islower(*c)) {
			*c = *c-'a' + UCS4_Wa;
		} else if(ucs4_isupper(*c)) {
			*c = *c-'A' + UCS4_WA;
		}
	}
	convUCS4toUTF8(ustr, (utf8_t *)d);
	return d;
}

utf8_t *
tex_column_to_sqlname(EdbContext ec, EdbColumnInfo ci)
{
	static char	*roman[10] = {"Z", "I", "II", "III", "IV", "V", "VI", "VII", "VIII", "IX"};
	Link	l_sn;
	utf8_t	*s;

	l_sn = link_atom_new("Column", NULL);
	for(s=ci->name.english; *s; ++s) {
		if(isdigit(*s)) {
			LinkAppend(l_sn, link_atom_new(roman[*s-'0'], NULL));
		} else {
			char	buf[2];
			buf[0] = *s;
			buf[1] = '\0';
			LinkAppend(l_sn, link_atom_new_sdup(buf));
		}
	}
	s = (utf8_t *)str_concatenate0(l_sn);
	EdbLinkFree(l_sn);
	return s;
}

